#include <boost/asio.hpp> /// just including this requires to link with boost system :-(

#include <iostream>
#include <thread>

namespace
{

void task1()
{
    std::cout << " task 1 starting" << std::endl;

    std::this_thread::sleep_for(std::chrono::seconds(2));
    std::cout << " task 1 still busy" << std::endl;
    std::this_thread::sleep_for(std::chrono::seconds(2));

    std::cout << " task 1 finished" << std::endl;
    std::cout <<  std::endl;
}

void task2()
{
    std::cout << " task 2 starting" << std::endl;

    std::this_thread::sleep_for(std::chrono::seconds(2));
    std::cout << " task 2 still busy" << std::endl;
    std::this_thread::sleep_for(std::chrono::seconds(2));

    std::cout << " task 2 finished" << std::endl;
    std::cout <<  std::endl;
}


void postTasks()
{
    boost::asio::io_service ioService;

    std::cout << "Posting 2 tasks to the service." << std::endl;

    /// USING THE NEW WAY, member method has been deprecated
    boost::asio::post(ioService, task1);
    boost::asio::post(ioService, task2);

    ioService.run();

    std::cout << "run() returned, which means all tasks have finished." << std::endl;
    std::cout <<  std::endl;
}

} // namespace

int main()
{
    std::cout << "let's have the ioservice being run in a dedicated thread so our main thread remains available for other work" << std::endl;
    std::thread t{postTasks};

    for(auto idx = 0; idx < 7; ++idx)
    {
        std::cout << "heavy work being done in main thread."  << std::endl;
        std::this_thread::sleep_for(std::chrono::seconds(1));
    }

    t.join();

    std::cout << "all have finished, time to go home." << std::endl;
    std::cout <<  std::endl;
}
