#include <boost/asio.hpp> /// just including this requires to link with boost system :-(

#include <iostream>
#include <thread>
#include <functional>

namespace
{

void task(int i)
{
    std::cout << " task execution : i = " << i << std::endl;
    std::this_thread::sleep_for(std::chrono::seconds(2));
}

void postTasks(boost::asio::io_service& ioService)
{
    for(int i = 0; i < 10; ++i)
    {
        ioService.post(std::bind(task, i));
    }
}

void workerThread(boost::asio::io_service& ioService)
{
    ioService.run();
}

} // namespace

int main()
{
    {
        boost::asio::io_service ioService;
        postTasks(ioService);

        std::cout << "ALL tasks by 1 io service processed by the 1 thread" << std::endl;
        std::thread t{workerThread, std::ref(ioService)};
        t.join();
    }
    std::cout << std::endl;
    {
        boost::asio::io_service ioService;
        postTasks(ioService);

        std::cout << "ALL tasks by 1 io service processed by the multiple threads" << std::endl;
        std::thread t1{workerThread, std::ref(ioService)};
        std::thread t2{workerThread, std::ref(ioService)};
        std::thread t3{workerThread, std::ref(ioService)};
        t1.join();
        t2.join();
        t3.join();
    }
}
