#include <iostream>
#include <functional>
#include <chrono>
#include <boost/asio/steady_timer.hpp>

namespace
{

void seek(const boost::system::error_code& /*erc*/)
{
    std::cout << "and seek" << std::endl;
}

void hide(
        const boost::system::error_code& /*erc*/,
        boost::asio::steady_timer& timer)
{
    std::cout << "hide" << std::endl;

    timer.expires_after(std::chrono::seconds(3));
    timer.async_wait(seek);
}

} // namespace

int main()
{
    boost::asio::io_context ioContext;
    boost::asio::steady_timer timer{ioContext, std::chrono::seconds(5)};

    std::cout << "wait for participants"  << std::endl;

    timer.async_wait(std::bind(hide, std::placeholders::_1, std::ref(timer)));

    ioContext.run();
}
