#include <iostream>
#include <functional>
#include <chrono>
#include <boost/asio/steady_timer.hpp>

#define BOOST_COROUTINES_NO_DEPRECATION_WARNING
#include <boost/asio/spawn.hpp> /// this is now deprecated, but you could still use it ...
/// ==> this is the new library #include <boost/coroutine2/all.hpp> ===> but that is a different talk

namespace
{

void hideAndSeek(
        boost::asio::yield_context yield,
        boost::asio::io_context& ioContext)
{
    std::cout << "wait for participants"  << std::endl;

    boost::asio::steady_timer timer{ioContext, std::chrono::seconds(5)};
    timer.async_wait(yield);

    std::cout << "hide" << std::endl;

    timer.expires_after(std::chrono::seconds(3));
    timer.async_wait(yield);

    std::cout << "and seek" << std::endl;
}

} // namespace

int main()
{
    boost::asio::io_context ioContext;

    boost::asio::spawn(
            ioContext,
            std::bind(hideAndSeek, std::placeholders::_1, std::ref(ioContext)));

    ioContext.run();
}
