#include <boost/asio.hpp>

#include <thread>
#include <iostream>
#include <string>

namespace
{

const boost::asio::ip::tcp::endpoint ep{boost::asio::ip::make_address("127.0.0.1"), 8242};

void getServed(
        boost::asio::io_context& ioContext,
        const std::string& message)
{

	boost::asio::ip::tcp::socket sock{ioContext};
	sock.connect(ep);
	std::cout << "client connected" << std::endl;

	boost::asio::write(sock, boost::asio::buffer(message));

	/// shutdown writing on our socket so server knows entire message has arrived
    sock.shutdown(boost::asio::socket_base::shutdown_send);

    boost::system::error_code ec;
    std::string answer;
    boost::asio::read(
            sock,
            boost::asio::dynamic_buffer(answer),
            ec);
    if(ec == boost::asio::error::eof)
    {
        std::cout << "server replied : " << answer << std::endl;
    }
    else
    {
        std::cout << "error." << std::endl;
    }

	sock.close();
}

} // namespace

int main()
{
    boost::asio::io_context ioContext;

    getServed(ioContext, "hello");

    getServed(ioContext, "world");
}
