#include <iostream>
#include <boost/asio.hpp>

/// we want to connect to the http of google

/// we need a SOCKET for that purpose

/// sockets of type : tcp / udp / icmp


namespace
{

auto resolveTcp(const std::string& host, const std::string& service)
{
	boost::asio::io_context ioService;
	boost::asio::ip::tcp::resolver res{ioService};

    return res.resolve(host, service);
}

} // namespace

int main()
{
	const auto& results =  resolveTcp("www.google.com", "http");
	if(results.empty())
    {
        std::cout << " could not resolve, it stops here";
        return 0;
    }

    boost::asio::io_context ioService;
    boost::asio::ip::tcp::socket socket{ioService};

    boost::system::error_code ec;
    boost::asio::connect(socket, results, ec);
    if(ec)
    {
        std::cout << "Connect failed : " << ec.message() << std::endl;
        return 0;
    }

    socket.write_some(boost::asio::buffer("GET /index.html\r\n"));


    char buffer[1000]{};
    const size_t read = socket.read_some(boost::asio::buffer(buffer));

    std::cout << "Received length : " << read << std::endl << std::endl;
    std::cout << buffer << std::endl;
}
