#include <iostream>
#include <boost/asio.hpp>

/// communication happens between 2 endpoints
/// endpoint : IP addres + (service) port


namespace
{
const unsigned short port{60000};

}

int main()
{
    /// TCP
	{
		const boost::asio::ip::tcp::endpoint ep;
		std::cout << ep << std::endl;	/// 0.0.0.0:0
	}

	{
		const boost::asio::ip::tcp::endpoint ep{boost::asio::ip::tcp::v4(), port};
		std::cout << ep << std::endl;	/// 0.0.0.0:60000
	}

	{
		const boost::asio::ip::tcp::endpoint ep{boost::asio::ip::tcp::v6(), port};
		std::cout << ep << std::endl;	/// [::]:60000
	}

	{
		const boost::asio::ip::tcp::endpoint ep{boost::asio::ip::address::from_string("192.168.0.1"), port};
		std::cout << ep << std::endl;
	}

	/// UDP
	{
		const boost::asio::ip::udp::endpoint ep{boost::asio::ip::udp::v4(), port};
		std::cout << ep << std::endl;	/// 0.0.0.0:60000
	}

	{
		const boost::asio::ip::udp::endpoint ep{boost::asio::ip::udp::v6(), port};
		std::cout << ep << std::endl;	/// [::]:60000
	}
}
