#include <iostream>
#include <boost/asio.hpp>

/// resolvers for : tcp / udp / icmp
/// reverse lookup, just specify endpoint, no need for query


namespace
{

void ResolveTcp(const std::string& ip, unsigned short port)
{
	boost::asio::io_service ioService;
	boost::system::error_code ec;

	boost::asio::ip::tcp::resolver res(ioService);

	boost::asio::ip::tcp::endpoint endPoint{boost::asio::ip::address::from_string(ip), port};
	boost::asio::ip::tcp::resolver::iterator it = res.resolve(endPoint, ec);
	if(ec)
	{
		std::cout << "Oops : " << ec.message() << std::endl;
		return;
	}

	boost::asio::ip::tcp::resolver::iterator end;
	while(it != end)
	{
		std::cout << "Host name : " << it->host_name() << std::endl;
		std::cout << "Service name : " << it->service_name() << std::endl;
		++it;
	}
}

} // namespace

int main()
{
	ResolveTcp("127.0.0.1", 0);
	std::cout << std::endl;

	ResolveTcp("127.0.0.1", 80);
	std::cout << std::endl;

	ResolveTcp("127.0.0.1", 25);
	std::cout << std::endl;

	ResolveTcp("127.0.0.1", 21);
	std::cout << std::endl;

	ResolveTcp("173.194.66.103", 80);
	std::cout << std::endl;
}
